<template>
<div class="">
    <div class="hero-body" style="overflow-y: scroll;height: 80vh;flex-shrink: 1; padding-bottom: 0;" id="chatbody" v-chat-scroll="{always: false, smooth: true}">
        <div class="container" style="margin: 0 auto;">
            <div class="columns" v-for="msg in convos" :key="msg.key">
                <div class="column">

                    <article v-if="msg.uid == uid" class="media">
                        <figure class="media-left"><!----></figure> 
                        <div class="media-content">
                            <div class="content box">
                                <p>
                                    <strong>{{msg.name}}</strong> 
                                    <small></small> 
                                        <small class="timeago" :datetime="msg.ts"></small>
                                        <br>
                                        {{msg.msg}} 
                                </p>
                            </div>
                        </div> 
                        
                        <div class="media-right">
                            <p class="image is-64x64 sui-avatar">
                               
                            </p>
                        </div>
                    </article>

                    <article v-else class="media">
                        <div class="media-left">
                            <p class="image is-64x64 sui-avatar">
                                
                            </p>
                        </div> 
                        <div class="media-content">
                            <div class="content box">
                                <p>
                                    <strong>{{msg.name}}</strong> 
                                    <small></small> 
                                        <small class="timeago" :datetime="msg.ts"></small>
                                        <br>
                                        {{msg.msg}} 
                                </p>
                            </div>
                        </div> 
                        
                        <figure class="media-right">
                            <!---->
                        </figure>
                    </article>

                </div>
            </div>
        </div>
    </div>
    <div class="hero-foot" style="flex-grow: 0;flex-shrink: 0;">
        <div class="container">
            <div class="field is-grouped is-horizontal">
                <p class="control is-expanded">
                    <textarea type="text" placeholder="Type a message" class="textarea" v-model="msg"></textarea>
                </p> 
                <p class="control">
                    <button class="button is-medium" :class="{'is-primary': ready}" @click="send">
                        <span class="icon is-small"><i class="fa fa-send"></i></span>
                    </button>
                </p>
            </div>
        </div>
    </div>
</div>
</template>

<script>
import { DB } from "@/plugins/firebase.js";
import timeago from "timeago.js";

export default {
  data: function() {
    return {
      convo: [],
      uid: this.$store.getters.isAuthenticated,
      chatid: this.$route.query.id,
      msg: 'test',
      room: null
    }
  },
  methods: {
    loadChat: function() {

        DB.ref()
        .child("/topics/" + this.chatid + "/chat")
        .off();

        DB.ref()
        .child("/topics/" + this.chatid + "/chat")
        .on("child_added", data => {
            // push the snapshot value into a data attribute
            self.convo.push(data.val())
            .then(function() {
                self.scrollbottom();
            })
            console.log('pushing value to msg');
        })

    },
    shout: function(topic) {
      console.log(topic);
      this.$router.push({ path: "/chat", query: { id: topic } });
    },
    send: function() {
        if (this.msg == '') {
            var send = false 
        }
        else {
            send = true 
        }
        var msg = this.msg 
        var self = this
        this.msg = ''
        var ts = new Date().getTime()
        //var ts = DB.ServerValue.TIMESTAMP
        var newPostKey = DB.ref().child('/topics/' + this.chatid + '/chat/').push().key
        var chatObj = {
            ts: ts,
            msg: msg,
            uid: this.uid,
            key: newPostKey
        }

        var updates = {}
              
        updates['/users/' + this.room.creator.uid + '/chats/' + this.chatid + '/msg'] = chatObj
        
        updates['/users/' + this.room.joiner.uid + '/chats/' + this.chatid + '/msg'] = chatObj
        
        updates['/topics/' + this.chatid + '/chat/' + newPostKey] = chatObj
        
        if(send) {
            DB.ref().update(updates)
            /* .then(() => {
             self.scrollbottom()
            }) */
            .catch(function(error) {
                self.$izitoast.error({
                    title: 'Uhh',
                    message: "something failed..."
                })
            })
        }

    },
    scrollbottom: function () {
        var element = document.getElementById("chatbody")
        element.scrollTop = element.scrollHeight
    }
  },
  mounted() {

    //this.loadedts = DB.ServerValue.TIMESTAMP

    self = this 

    DB.ref()
    .child("/users/" + self.uid + "/chats/" + self.chatid)
    .once("value", function(data) {
        console.log(data.val())
        let val = data.val()
        self.room = val
    })

    //this.loadChat()

    DB.ref().child("/topics/" + this.chatid + "/chat").off();

    DB.ref()
    .child("/topics/" + this.chatid + "/chat")
    .on("child_added", (data) => {
        // push the snapshot value into a data attribute
        self.convo.push(data.val())
        .then( ()=> {
            //self.scrollbottom();
        })
        console.log('pushing value to msg');
    })

    //self.scrollbottom();

  },
  updated() {
    timeago().render(document.querySelectorAll(".timeago"));
    this.scrollbottom();
  },
  computed: {
      ready: function() {
          if (this.msg == '') {
              return false
          }
          else {
              return true 
          }
      },
        convos: function () {
            var convo = this.convo 
            
            if (this.convo.length == 0) {
                return this.convo
            }
            else {
                var creator = this.room.creator.uid
                var joiner = this.room.joiner.uid

                for( var i = 0; i < convo.length; i++){ 
                    if (convo[i].uid == creator) {
                        convo[i].name = this.room.creator.name
                    }
                    else if (convo[i].uid == joiner) {
                        convo[i].name = this.room.joiner.name
                    }
                    else {
                        convo[i].name = "unknown"
                    }
                }
                
                return convo
            }
        }
  }
  //middleware: 'auth'
};
</script>
